#ifndef code__json__marshaling__marshaling_hxx_
#define code__json__marshaling__marshaling_hxx_

#include <code/json/variant.hxx>

#include <code/json/marshaling/marshaling-context.hxx>
#include <code/json/marshaling/marshaling-traits.hxx>

#include <utility>

namespace code::json::marshaling {

template< typename T >
variant
marshal(T const& model, marshaling_context* context = nullptr)
{
  return marshaling_traits< T >::marshal(model, context);
}

template< typename T >
typename marshaling_traits< T >::model_type
unmarshal(variant const& value, marshaling_context* context = nullptr)
{
  return marshaling_traits< T >::unmarshal(value, context);
}

} // namespace code::json::marshaling

#endif
